[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.116 and 1.122

version 1.116, 2021/12/23 21:46:46 version 1.122, 2021/12/24 02:36:13
Line 67 
Line 67 
         "$VERBOSE" && flags=-vm          "$VERBOSE" && flags=-vm
         if [ -x /usr/bin/su ]; then          if [ -x /usr/bin/su ]; then
                 exec /usr/bin/su -s /bin/ksh "$_user" -c \                  exec /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"                      "/usr/bin/ftp -N '${0##/}' -D 'Get/Verify' $flags -o- '$_src'" > "$_dst"
         else          else
                 exec /usr/bin/doas -u "$_user" \                  exec /usr/bin/doas -u "$_user" \
                     /usr/bin/ftp -D 'Get/Verify' $flags -o- "$_src" > "$_dst"                      /usr/bin/ftp -N "${0##/}" -D 'Get/Verify' $flags -o- "$_src" > "$_dst"
         fi          fi
         ) & _pid=$!          ) & _pid=$!
         set +o monitor          set +o monitor
Line 173 
Line 173 
         local _tmpdir="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"          local _tmpdir="$( tmpdir "${DESTDIR}/var/db/pkg/.firmware" )"
         local flags=-VM          local flags=-VM
         "$VERBOSE" && flags=-vm          "$VERBOSE" && flags=-vm
         ftp -D "Install" "$flags" -o- "file:${1}" |          ftp -N "${0##/}" -D "Install" "$flags" -o- "file:${1}" |
                 tar -s ",^\+,${_tmpdir}/+," \                  tar -s ",^\+,${_tmpdir}/+," \
                     -s ",^firmware,${DESTDIR}/etc/firmware," \                      -s ",^firmware,${DESTDIR}/etc/firmware," \
                     -C / -zxphf - "+*" "firmware/*"                      -C / -zxphf - "+*" "firmware/*"
Line 241 
Line 241 
 }  }
   
 usage() {  usage() {
         echo "usage:  ${0##*/} [-d | -D | -L] [-av] [driver | file ...]"          echo "usage:  ${0##*/} [-d | -D] [-av] [-p path] [driver | file ...]"
         exit 2          exit 2
 }  }
   
 ALL=false  ALL=false
 OPT_D=  OPT_D=
 OPT_L=  while getopts :adDp:v name
 while getopts :adDLv name  
 do  do
        case "$name" in         case "$name" in
        a) ALL=true ;;         a) ALL=true ;;
        d) DELETE=true ;;         d) DELETE=true ;;
        D) OPT_D=true ;;         D) OPT_D=true ;;
        L) OPT_L=true ;;         p) LOCALSRC="$OPTARG" ;;
        v) VERBOSE=true ;;         v) VERBOSE=true ;;
        ?) echo "${0##*/}: unknown option -- -$OPTARG"; usage 2 ;;         :)
              echo "${0##*/}: option requires an argument -- -$OPTARG" >&2
              usage 2
              ;;
          ?)
              echo "${0##*/}: unknown option -- -$OPTARG" >&2
              usage 2
              ;;
        esac         esac
 done  done
 shift $((OPTIND - 1))  shift $((OPTIND - 1))
   
 [ "$OPT_D" ] && [ "$OPT_L" ] && usage 1  if [ "$LOCALSRC" ]; then
           if [[ $LOCALSRC = @(ftp|http?(s))://* ]]; then
                   FWURL="${LOCALSRC}"
                   LOCALSRC=
           else
                   LOCALSRC="${LOCALSRC:#file:}"
                   ! [ -d "$LOCALSRC" ] &&
                       echo "The path must be a URL or an existing directory" >&2 &&
                       exit 2
           fi
   fi
   
   # "Download only" means local dir and don't install
 if [ "$OPT_D" ]; then  if [ "$OPT_D" ]; then
         # "Download only" means local dir and don't install  
         INSTALL=false          INSTALL=false
         LOCALSRC=.          LOCALSRC="${LOCALSRC:-.}"
 elif [ "$OPT_L" ]; then  
         # "Local" means don't download, install from local dir  
         DOWNLOAD=false  
         LOCALSRC=.  
 else  
         LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"  
 fi  fi
   
   [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/${0##*/}" )"
   
 CFILE="$LOCALSRC/$CFILE"  CFILE="$LOCALSRC/$CFILE"
   
 if "$INSTALL" || "$DELETE"; then  if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then
         if [ -x /usr/bin/id ] && [ "$(/usr/bin/id -u)" != 0 ]; then          echo "need root privileges" >&2
                 echo "need root privileges" >&2          exit 1
                 exit 1  
         fi  
 fi  fi
   
 set -A devices -- "$@"  set -A devices -- "$@"
   
 if "$DELETE"; then  if "$DELETE"; then
         [ "$OPT_D" ] || [ "$OPT_L" ] && usage 22          [ "$OPT_D" ] && usage 22
   
         set -A installed          set -A installed
         if [ "${devices[*]:-}" ]; then          if [ "${devices[*]:-}" ]; then
Line 343 
Line 353 
         set -o noclobber          set -o noclobber
         ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
             echo "Signature check of SHA256.sig failed" >&2 && exit 1              echo "Signature check of SHA256.sig failed" >&2 && exit 1
   elif [ ! -e "$CFILE" ]; then
           # TODO: We shouldn't need a CFILE if all arguments are files.
           echo "${0##*/}: $CFILE: No such file or directory" >&2
           exit 2
 fi  fi
   
 added=''  added=''
Line 376 
Line 390 
                 if "$DOWNLOAD"; then                  if "$DOWNLOAD"; then
                         "$VERBOSE" && echo "Verify existing ${f##*/}"                          "$VERBOSE" && echo "Verify existing ${f##*/}"
                         verify "$f" || continue                          verify "$f" || continue
                           "$INSTALL"  || kept="$kept,$d"
                 # else assume it was verified when downloaded                  # else assume it was verified when downloaded
                 fi                  fi
         elif "$DOWNLOAD"; then          elif "$DOWNLOAD"; then
                 fetch  "$f" || continue                  fetch  "$f" || continue
                 verify "$f" || continue                  verify "$f" || continue
                   "$INSTALL"  || added="$added,$d"
         elif "$INSTALL"; then          elif "$INSTALL"; then
                 echo "Cannot install ${f##*/}, not found" >&2                  echo "Cannot install ${f##*/}, not found" >&2
                 continue                  continue
Line 408 
Line 424 
 added="${added:#,}"  added="${added:#,}"
 updated="${updated:#,}"  updated="${updated:#,}"
 kept="${kept:#,}"  kept="${kept:#,}"
 echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"  if "$INSTALL"; then
           echo  "${0##*/}: added ${added:-none}; updated ${updated:-none}; kept ${kept:-none}"
   else
           echo  "${0##*/}: downloaded ${added:-none}; kept ${kept:-none}"
   fi

Legend:
Removed from v.1.116  
changed lines
  Added in v.1.122

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>